import java.io.IOException;
import javax.microedition.lcdui.*;

public class cornersCanvas extends Canvas implements CommandListener {
 private midlet midlet;
 private Display dpy;
 private Displayable prev;
 private boolean first=true;
 private static int mode=0;
 private static String paintStr="";
 private static int paintI,paintJ;
 
 private int topBoard,leftBoard;
 public static int cursorX=7,cursorY=0,oldX=0,oldY=0;
 private Image [] img= { null,null,null,null,null,null,null,null};
 private String[] imgNames = { "1","0","00","01","10","11","00a","10a" };
 private int [][] local_path;
 private int [] f_hod;
 private int [] hod;
 private int [] hod_k;
 private static final int 
  imgSize=13,
  backColor=0x00ffff,
  cursorColor = 0xff0000,
  textColor=0x000000;
 private random Rand = new random ();
 private Command cmdBack = new Command("", Command.BACK, 1);
 private Command cmdExit = new Command("", Command.EXIT, 2);

 private int vars,len,gg,start_search;
 private int [] selected;
 private int [] to;
 private String [] letr= {"a","b","c","d","e","f","g","h"};

 private tonePlayer tp = new tonePlayer ();
 private boolean inPress=false;
 private Font font;

 public cornersCanvas (midlet midlet) {
  super ();
  this.midlet = midlet;
  dpy = Display.getDisplay (midlet);
  prev = dpy.getCurrent();
  for (int i=0; i<8; i++) {
   try { 
    img[i] = Image.createImage("/"+imgNames[i]+".png"); 
   }
   catch (java.io.IOException e) {}
  }
  local_path = new int [60][2];
  f_hod = new int [60];
  hod = new int [60];
  hod_k = new int [60];
  selected = new int [2];  
  to = new int [2];        
  addCommand(cmdBack);
  addCommand(cmdExit);
  font = Font.getFont (Font.FACE_SYSTEM, Font.STYLE_PLAIN, Font.SIZE_SMALL);
  setCommandListener (this);
  setFullScreenMode (true);
 }

 private Image getImageByName (String s) {
  for (int i=0; i<8; i++) if (imgNames[i].compareTo(s)==0) return img[i];
  return null;
 }

 private Image getImage (int i,int j) {
  String s="";
  if (options.my_turn==2 && i==selected[0] && j==selected[1]) {
   if ((i+j)%2==0) s="00a";
   else s="10a";
  }
  else {
   switch (options.board[i][j]) {
    case 1: s="01"; break;
    case 0: s="00"; break;
    case 10: s="10"; break;
    case 11: s="11"; break;
    case 21: s="1"; break;
    case 20: s="0"; break;
   }
  }
  return getImageByName (s);
 }

 public static void newGame () {
  for (int i=0; i<8; i++)
  for (int j=0; j<8; j++) {
   if ((i<5) && (j<4) || (i>2) && (j>3)) 
    options.board[i][j]=((i+j)%2==0 ? 20 : 21);
   else if ((i>4) && (j<4)) 
    options.board[i][j]=((i+j)%2==0 ? 0 : 10);
   else options.board[i][j]=((i+j)%2==0 ? 1 : 11);
  }
  int k=0;
  for (int i=0; i<3; i++) //.     
  for (int j=0; j<4; j++) options.compr[k++]=4+i*10+j;
  cursorX=5; oldX=0;
  cursorY=0; oldY=0;
  options.my_turn = 1;
 }

 private int [] coord (int x,int y) { //   ""
  int [] c = new int [2];
  c[0]=x; c[1]=y;
  return c;
 }

 private int [] getcompcoord(int n) { // x-  y-     n
  int y=n%10;
  int x=(n-y)/10;
  return coord(x,y);
 }

 private String notate (int [] f) { //   f
  return letr[f[1]]+(8-f[0]);
 }

 private String notation (int [] from,int [] to) { //     from  to
  return notate(from)+"-"+notate(to);
 }

 private void getBoard (Graphics g) {
  int i,j;
  g.setFont (font);
  for (i=0; i<8; i++) {
   for (j=0; j<8; j++) g.drawImage (getImage (i,j),leftBoard+j*imgSize,topBoard+i*imgSize,Graphics.TOP|Graphics.LEFT);
   g.drawString (letr[i], leftBoard + i*imgSize + imgSize/2, topBoard - 2 - font.getHeight(), Graphics.TOP|Graphics.HCENTER);
  }
  for (i=0; i<8; i++)
   g.drawString (""+(8-i), leftBoard - 2 - font.charWidth((char)(8-i)), topBoard +i*imgSize + (imgSize-font.getHeight())/2, Graphics.TOP|Graphics.LEFT);
 }

 protected void paint (Graphics g) {
  if (first==true) {
   colorGradient cg= new colorGradient (g, getWidth(), getHeight());
   cg.draw (0x0066cc, backColor);
   topBoard=(getHeight()-8*imgSize)/2;
   leftBoard=(getWidth()-8*imgSize)/2;
   g.setColor (textColor);
   g.drawRect (leftBoard-1, topBoard-1, 8*imgSize+1, 8*imgSize+1);
   getBoard (g);
   first=false;
  }
  if (mode==1) { //
   g.setColor (backColor);
   g.setFont (font);
   g.fillRect (leftBoard, topBoard + 8*imgSize+ 2, 8*imgSize, font.getHeight()+4);
   g.setColor (textColor);
   g.drawString (paintStr, leftBoard, topBoard + 8*imgSize + 4, Graphics.TOP|Graphics.LEFT);
  }
  else if (mode==2) { //
   g.drawImage (getImageByName (paintStr),leftBoard+paintJ*imgSize,topBoard+paintI*imgSize,Graphics.TOP|Graphics.LEFT);
  }
  //
  if ((oldX!=cursorX) || (oldY!=cursorY) || (mode==2)) {
   if (mode!=2) g.drawImage (getImage (oldX,oldY),leftBoard+oldY*imgSize,topBoard+oldX*imgSize,Graphics.TOP|Graphics.LEFT);
   g.setColor (cursorColor);
   g.drawRect (leftBoard+cursorY*imgSize+1,topBoard+cursorX*imgSize+1,imgSize-3,imgSize-3);
   g.drawRect (leftBoard+cursorY*imgSize+2,topBoard+cursorX*imgSize+2,imgSize-5,imgSize-5);
  }
  oldX = cursorX; oldY = cursorY;
  mode=0;
 }

 private int [] left (int [] f,int dir,int n) { 
  //  ,    f  n    dir
  // (10,10),    
  int [] to=coord(10,10);
  if (dir==0) {//
   if (f[0]-n>=0) { to[0]=f[0]-n; to[1]=f[1]; }
  }
  else if (dir==1) {//
   if (f[0]+n<8) { to[0]=f[0]+n; to[1]=f[1]; }
  }
  else if (dir==2) {//
   if (f[1]-n>=0) { to[0]=f[0]; to[1]=f[1]-n; }
  }
  else if (dir==3) {//
   if (f[1]+n<8) { to[0]=f[0]; to[1]=f[1]+n; }
  }
  return to;
 }

 private boolean free (int x,int y) { //,   (x,y) 
  if (options.board[x][y]>19) return true;
  return false;
 }

 private int kol_free (int x,int y) { //     (x,y)
  int kol=0;
  if ((x>0) && (free(x-1,y)==true)) { kol++; }
  if ((x<7) && (free(x+1,y)==true)) { kol++; }
  if ((y>0) && (free(x,y-1)==true)) { kol++; }
  if ((y<7) && (free(x,y+1)==true)) { kol++; }
  return kol;
 }

 private boolean white (int x, int y) { //,    (x,y)      
  if ((options.board[x][y]==10) || (options.board[x][y]==0)) {
   int n=0;
   int [] from=coord(x,y);
   for (int i=0; i<4; i++) {
    int [] to=left(from,i,2);
    if ((to[0]<10) && (free(to[0],to[1])==true)) n++;
   }
   if ((n>0) || (kol_free(x,y)>0)) return true;
   else { paintStr=" "; mode=1; repaint(); serviceRepaints();}
  }
  else { paintStr="  "; mode=1; repaint(); serviceRepaints();}
  return false;
 }

 private int abs (int num) {
  return (num>-1 ? num : -num);
 }

 private boolean near (int [] f1,int [] f2) { //,   f1  f2 
  int dx=abs(f1[0]-f2[0]);
  int dy=abs(f1[1]-f2[1]);
  if ( (dx==1) && (dy==0) || (dx==0) && (dy==1)) return true;
  return false;
 }

 private int opposite (int dir) { // ,  dir
  if (dir==0) return 1;
  else if (dir==1) return 0;
  else if (dir==2) return 3;
  else if (dir==3) return 2;
  return dir;
 }

 private boolean way (int [] f1,int [] f2,int fromdir) { 
  //,       f1  f2
  //fromdir - ,   -    
  for (int i=0; i<4; i++) { // 
   int [] to = new int [2];
   to=left (f1,i,2);
   if ((to[0]<10) && (free(to[0],to[1])==true)) { //     
    int [] f0 = new int [2];
    f0=left(f1,i,1);
    if (free(f0[0],f0[1])==false) { //  
     if ((to[0]==f2[0]) && (to[1]==f2[1])) {
      return true;
     }
     else if (i!=fromdir) {
      boolean go=true;
      for (int k=0; k<len; k++) {
       if ( (local_path[k][0]==to[0]) && (local_path[k][1]==to[1]) ) { go=false; }
      }
      if (go==true) {
       local_path[len][0]=to[0];
       local_path[len++][1]=to[1];
       boolean r=way (to,f2,opposite(i));
       if (len>0) len--;
       if (r==true) return true;
       continue;
      }
     }
    }
   }
  }
  return false; 
 }

 private boolean legal_move (int [] from, int [] to) {
  if ((to[0] < 0) || (to[0] < 0) || (to[1] > 7) || (to[1] > 7)) return false;
  if ((free(to[0],to[1])==true) && (near(from,to)==true)) return true;
  len=1;
  local_path[0][0]=from[0]; local_path[0][1]=from[1];
  return way (from,to,-1);
 }

 private void move (int [] from, int [] to) { // 
  int col=options.board[from[0]][from[1]]%10;
  if ((from[0]+from[1])%2==0) options.board[from[0]][from[1]]=20;
  else options.board[from[0]][from[1]]=21;
  paintI=from[0]; paintJ=from[1]; paintStr=""+options.board[from[0]][from[1]]%10; mode=2; repaint(); serviceRepaints();
  if ((to[0]+to[1])%2==0) options.board[to[0]][to[1]]=col;
  else options.board[to[0]][to[1]]=10+col;
  paintI=to[0]; paintJ=to[1]; paintStr=((to[0]+to[1])%2==0?"0":"")+options.board[to[0]][to[1]]; mode=2; repaint(); serviceRepaints();
 }

 private boolean placed (int [] my) { //,     
  if ((my[0]>4) && (my[1]<4)) return true;
  else return false;
 }

 private int comp_placed () { //    
  int kol=0;
  int [] my=new int [2];
  for (int t=0; t<12; t++) {
   my=getcompcoord(options.compr[t]);
   if (placed (my)==true) kol++;
  }
  return kol;
 }

 private int minlen; //   . 
 private int [] from_r={10,10};
 private int [] to_r={10,10};
 private int fish_r;
 private int rec_deep=5; //   

 private void recurse (int [] fil,int rec) { //      (  rec)
  if (comp_placed()==12) {
   if (len<minlen) {
    minlen=len;
    from_r=getcompcoord(f_hod[0]);
    to_r=getcompcoord(hod[0]);
    fish_r=hod_k[0];
   }
   return;
  }
  if (rec==rec_deep) return;
  for (int i=0; i<12; i++) {
   int [] my= new int [2];
   my=getcompcoord(options.compr[i]);
   for (int dir=0; dir<4; dir++) {
    for (int dis=1; dis<3; dis++) {
     int [] to = new int [2];
     to=left(my,dir,dis);
     if ((to[0]==fil[0]) && (to[1]==fil[1])) {
      f_hod[len]=options.compr[i];// 
      hod[len]=fil[0]*10+fil[1]; // 
      hod_k[len++]=i; // 
      fil=getcompcoord(options.compr[i]);
      options.compr[i]=to[0]*10+to[1];
      recurse (fil,rec+1);
      if (len>0) len--;
      options.compr[i]=f_hod[len];
      fil=getcompcoord(hod[len]);
     }
    } 
   }
  }
 }

 private int man_placed () { //    
  int kol=0;
  for (int i=0; i<3; i++) 
  for (int j=4; j<8; j++) 
   if ((options.board[i][j]==10) || (options.board[i][j]==0)) kol++;
  return kol;
 }

 private void make_move (int [] from,int [] to) { //     
  move (from,to);
  paintStr="  "+notation(from,to); mode=1; repaint(); serviceRepaints();
  //
  if (comp_placed()==12) {
   if (man_placed()<12) {
    options.c3++;
    paintStr=" !"; mode=1; repaint(); serviceRepaints();
   }
   else {
    options.c2++;
    paintStr=" !"; mode=1; repaint(); serviceRepaints();
   }
   midlet.game_is_over=true;
  }
  else if (man_placed()==12) {
   options.c1++;
   paintStr=" ..."; mode=1; repaint(); serviceRepaints();
   midlet.game_is_over=true;
  }
 }

 private int distance (int [] from, int [] to) { //   from  to
  return (abs(from[0]-to[0])+abs(from[1]-to[1]));
 }

 private int near_dist (int f) { //   f      
  int num=8;
  int [] my = new int [2];
  my=getcompcoord(f);
  int [] his = new int [2];
  int d;
  for (int t=0; t<12; t++) {
   if (options.compr[t]!=f) {
    his=getcompcoord(options.compr[t]);
    d=distance(my,his);
    if (d<num) num=d;
   }
  }
  return num;
 }

 private int max (int a,int b) { return ((a)>(b)?(a):(b)); }
 private int min (int a,int b) { return ((a)<(b)?(a):(b)); }

 private int goal (int nin,int n) { 
  //           nin  compr[nin] (  = n>=0)
  int res,pent;
  int [] my = new int [2];
  int [] to = new int [2];
  to=getcompcoord(options.compr[nin]);
  int [] start = new int [2];
  start=getcompcoord(start_search);
  int [] corner = new int [2];
  //int dist1=near_dist(options.compr[nin]);//     - 
  res=0; 
  pent=0;
  corner=coord(7,0);
  int pl=comp_placed();//-   
  if (pl==12) { gg=Integer.MIN_VALUE; return gg; }
  //
  for (int i=0; i<12; i++) { //  - -     
   my=getcompcoord(options.compr[i]);
   res+=distance(my,corner);
  }
  //:
  if (start[0]<2) {
   //if (pl<3) {
   // if ((start[0]==0) && (to[0]==0)) pent+=5;
   //} 
   if (to[0]>start[0] || distance(to,corner)<distance(start,corner)) pent-=3; // 
  } 
  if ( !( (start[0]<2) && (start[1]<2) || (start[0]>4) && (start[1]>4)  ) ) { //    
   if ( ((to[0]<3) && (to[1]<3)) || ((to[0]>4) && (to[1]>4))) { //     
    if ( (to[0]==2) && (to[1]==2) || (to[0]==5) && (to[1]==5) ) ; // c6,f3
    else if (max(to[0],to[1])==2 || min(to[0],to[1])==5) pent+=3;
    else if (max(to[0],to[1])==1 || min(to[0],to[1])==6) pent+=7;
    else pent+=11;
   }
  }
  if (n<2) {//  a5-a8, e1-h1
   if ((start[1]>0) && (to[1]==0) && (to[0]<4) || (start[0]<7) && (to[0]==7) && (to[1]>4)) pent+=5;
  }
  if (pl<7) { 
   if (placed (start)==true) pent+=2; //      
   //if ((n==0) && (dist1>2)) pent+=2; //  -,   
  }
  if (pl>9) { //          
   if (to[0]<start[0] || to[1]>start[1]) pent+=10;
   if ( (placed(start)==false) && (placed(to)==true) )  pent-=10;
   if ( (to[0]<=start[0]) && ((to[0]==3) || (to[0]==4)) && ((to[1]==0) || (to[1]==1)) ) pent+=10; //  a4-b5   - 
   else if ((to[0]>5) && (to[1]==4)) pent+=10; //e1-e2 
  }
  if (pl>7) { //     
   if ((placed(start)==true) && (placed(to)==false)) pent+=10;
   if (placed(start)==false) {
    if (placed(to)==true) pent-=10;
   }
   //if (distance(to,corner)<distance(start,corner)) pent-=5;
   if ( (start[1]!=2) && (to[0]<=start[0]) && (to[1]==2) && (to[0]<4) ) pent+=6; //c5-c8
   if (to[0]>5 && to[1]>3) pent+=6; 
  }
//System.out.println (""+options.compr[nin]+":"+(res+pent));//!!!
  return (res+pent);
 }

 private void links (int [] my,int nin,int fromdir,int [] compr) { //     my ( =nin)
 //compr -   ,     
 //fromdir - ,   -    
  for (int dir=0;dir<4;dir++) { // 
   int [] to = new int [2];
   to=left(my,dir,2);
   if ((to[0]<10) && (free(to[0],to[1])==true)) { //     
    int [] f0 = new int [2]; 
    f0=left(my,dir,1);
    if ( (free(f0[0],f0[1])==false) && (len<59)) { //  
     int temp=options.compr[nin];
     options.compr[nin]=to[0]*10+to[1];
     int g2=goal(nin,len);
     boolean go=true;
     int [] comp = new int [2];
     for (int k=0; k<len; k++) { //  ,    
      comp = getcompcoord (options.compr[nin]);
      if ((local_path[k][0]==comp[0]) && (local_path[k][1]==comp[1])) { go=false; break; }
     }
     if (go==true) {
      if (g2<gg) { 
       vars=0;
       gg=g2;
      }
      if (g2<=gg) {
       if (vars<59) {
        f_hod[vars]=start_search;//  -       !
        hod[vars]=options.compr[nin]; // 
        hod_k[vars++]=nin; // 
       }
      }
      comp = getcompcoord (options.compr[nin]);
      local_path[len][0]=comp[0]; local_path[len++][1]=comp[1];
      links (to,nin,opposite(dir),options.compr);
      if (len>0) len--;
     }
     options.compr[nin]=temp;
    }
   }
  }
 }

 private void move_comp () { // 
  int pl=comp_placed();
  int dist1,distmax=near_dist(options.compr[0]);
  for (int i=1; i<12; i++) {
   dist1=near_dist(options.compr[i]);
   if (dist1>distmax) distmax=dist1;
  }
  if ((pl==11) || (pl>9) && (distmax<2)) { // 
   int [] fil=new int [2];
   int [] fish=new int [2];
   fil=coord(10,10);
   for (int i0=5; i0<8; i0++)
   for (int j0=0; j0<4; j0++) {
    if (free(i0,j0)==true) fil=coord (i0,j0);
   }
   if (fil[0]<10) { //     
    for (int i0=0; i0<12; i0++) {
     fish=getcompcoord(options.compr[i0]);
     if (placed (fish)==false) break;
    }
    if ( (fish[0]!=4) && (fish[1]!=4) || (fish[0]==4) && (fish[1]==4)) {} //    
    else {
     len=0;
     minlen=rec_deep;
     recurse (fil,0);
     if (minlen<rec_deep) {
      options.compr[fish_r]=to_r[0]*10+to_r[1];
      make_move (from_r,to_r);
      return;
     }
    }
   }
  }
  //
  gg=Integer.MAX_VALUE;
  vars=0;
  for (int i=0; i<12; i++) {
   int [] my = new int [2];
   my=getcompcoord(options.compr[i]);
   for (int dir=0; dir<4; dir++) { //   
    int [] to = new int [2];
    to=left(my,dir,1);
    if ((to[0]<10) && (free(to[0],to[1])==true)) {
     start_search=options.compr[i]; 
     options.compr[i]=to[0]*10+to[1];
     int g2=goal(i,0);
     if (g2<gg) {
      vars=0; gg=g2;
     }
     if (g2<=gg) {
      if (vars<59) {
       f_hod[vars]=start_search;// 
       hod[vars]=options.compr[i]; // 
       hod_k[vars++]=i; // 
      }
     }
     options.compr[i]=start_search;
    }
   }
   len=1; //  
   int [] comp = new int [2];
   comp = getcompcoord (options.compr[i]);
   local_path[0][0]=comp[0];
   local_path[0][1]=comp[1];
   start_search=options.compr[i]; 
   links(my,i,-1,options.compr); //     
  }
  if (vars>0) { //   
   int num=Rand.get (vars); 
//!!!
   int [] corner = new int [2];
   corner=coord(7,0);
   int max=distance (getcompcoord(f_hod[0]),corner);
   for (int ii=1; ii<vars; ii++) {
    int mm=distance (getcompcoord(f_hod[ii]),corner);
    if (mm>max) { max=mm; num=ii; }
   }

   int num_k=hod_k[num]; // 
   options.compr[num_k]=hod[num];
   int [] to = new int [2];
   to=getcompcoord(options.compr[num_k]);
   int [] from = new int [2];
   from=getcompcoord(f_hod[num]);
   make_move (from,to);
  }
  else {
   options.c1++;
   paintStr=",  "; mode=1; repaint(); serviceRepaints();
   midlet.game_is_over=true;
  }
 }

 public void keyPressed(int keyCode) {
  if (inPress==false) {
   inPress=true;
   switch (getGameAction(keyCode)) {
    case Canvas.LEFT:
     if (cursorY > 0) cursorY--;
     else cursorY=7;
     repaint (); serviceRepaints();
    break;
    case Canvas.RIGHT:
     if (cursorY < 7) cursorY++;
     else cursorY=0;
     repaint (); serviceRepaints();
    break;
    case Canvas.DOWN:
     if (cursorX < 7) cursorX++;
     else cursorX=0;
     repaint (); serviceRepaints();
    break;
    case Canvas.UP:
     if (cursorX > 0) cursorX--;
     else cursorX=7;
     repaint (); serviceRepaints();
    break;
    case Canvas.FIRE:
     if (midlet.game_is_over==false) {
      if (options.my_turn==1) {
       if (white (cursorX,cursorY)==true) {
        selected = coord (cursorX,cursorY);
        paintI=selected[0]; paintJ=selected[1]; paintStr=(selected[0]+selected[1])%2==0 ? "00a" : "10a"; mode=2; repaint(); serviceRepaints();
        paintStr=notate(selected)+"-..."; mode=1; repaint(); serviceRepaints();
        options.my_turn=2;
       }
      }
      else if (options.my_turn==2) {
       to= coord (cursorX,cursorY);
       if (legal_move(selected,to)==true) {
        move (selected,to);
        paintStr=notate(selected)+"-"+notate(to); mode=1; repaint(); serviceRepaints();
        if (options.sound>0) tp.play (tp.notes[0]);
        options.my_turn=0;
        paintStr="..."; mode=1; repaint(); serviceRepaints();
        move_comp ();
        if (options.sound>0) tp.play (tp.notes[6]);
        options.my_turn=1;
       }
       else if ((to[0]==selected[0]) && (to[1]==selected[1])) { // 
        paintStr=" "+notate(selected); mode=1; repaint(); serviceRepaints();
        paintI=selected[0]; paintJ=selected[1]; paintStr=(selected[0]+selected[1])%2==0 ? "00" : "10"; mode=2; repaint(); serviceRepaints();
        options.my_turn=1;
       }
       else {
        paintStr=" "+notate(selected)+"-"+notate(to); mode=1; repaint(); serviceRepaints();
       }
      }
      else {
       paintStr="  "; mode=1; repaint(); serviceRepaints();
      }
     }
     else {
      paintStr="   "; mode=1; repaint(); serviceRepaints();
     }
    break;
    default:
    break;
   }
   inPress=false;
  }
 }

 public void commandAction (Command c, Displayable d)  {
  dpy.setCurrent (prev);
  if (c==cmdExit) midlet.exitMIDlet();
 }

}